Crypto++

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions
StreamTransformation Class Reference

interface for the data processing part of stream ciphers More...

`#include <cryptlib.h>`

Inheritance diagram for StreamTransformation:

List of all members.

## Public Member Functions

StreamTransformation & | Ref ()
| return a reference to this object, useful for passing a temporary object to a function that takes a non-const reference
virtual unsigned int | MandatoryBlockSize () const
| returns block size, if input must be processed in blocks, otherwise 1
virtual unsigned int | OptimalBlockSize () const
| returns the input block size that is most efficient for this cipher
virtual unsigned int | GetOptimalBlockSizeUsed () const
| returns how much of the current block is used up
virtual unsigned int | OptimalDataAlignment () const
| returns how input should be aligned for optimal performance
virtual void | ProcessData (byte *outString, const byte *inString, size_t length)=0
| encrypt or decrypt an array of bytes of specified length
virtual void | ProcessLastBlock (byte *outString, const byte *inString, size_t length)
| for ciphers where the last block of data is special, encrypt or decrypt the last block of data
virtual unsigned int | MinLastBlockSize () const
| returns the minimum size of the last block, 0 indicating the last block is not special
void | ProcessString (byte *inoutString, size_t length)
| same as ProcessData(inoutString, inoutString, length)
void | ProcessString (byte *outString, const byte *inString, size_t length)
| same as ProcessData(outString, inString, length)
byte | ProcessByte (byte input)
| implemented as {ProcessData(&input, &input, 1); return input;}
virtual bool | IsRandomAccess () const =0
| returns whether this cipher supports random access
virtual void | Seek (lword n)
| for random access ciphers, seek to an absolute position
virtual bool | IsSelfInverting () const =0
| returns whether this transformation is self-inverting (e.g. xor with a keystream)
virtual bool | IsForwardTransformation () const =0
| returns whether this is an encryption object
virtual std::string | AlgorithmName () const
| returns name of this algorithm, not universally implemented yet
virtual Clonable * | Clone () const
| this is not implemented by most classes yet

## Detailed Description

interface for the data processing part of stream ciphers

Definition at line 469 of file cryptlib.h.

## Member Function Documentation

virtual unsigned int StreamTransformation::OptimalBlockSize | ( |  | ) | const`[inline, virtual]`

returns the input block size that is most efficient for this cipher

Note:
  optimal input length is n * OptimalBlockSize() - GetOptimalBlockSizeUsed() for any n > 0

Reimplemented in ECB_OneWay.

Definition at line 480 of file cryptlib.h.

virtual void StreamTransformation::ProcessData | ( | byte * | outString,
|  | const byte * | inString,
|  | size_t | length
| ) |  | `[pure virtual]`

encrypt or decrypt an array of bytes of specified length

Note:
  either inString == outString, or they don't overlap

Implemented in CBC_Decryption, CBC_Encryption, ECB_OneWay, AuthenticatedSymmetricCipherBase, Weak1::ARC4_Base, and PublicBlumBlumShub.

virtual void StreamTransformation::ProcessLastBlock | ( | byte * | outString,
|  | const byte * | inString,
|  | size_t | length
| ) |  | `[virtual]`

for ciphers where the last block of data is special, encrypt or decrypt the last block of data

For now the only use of this function is for CBC-CTS mode.

Reimplemented in CBC_CTS_Decryption, and CBC_CTS_Encryption.

The documentation for this class was generated from the following file:

- cryptlib.h